ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.16
Committed: Tue May 31 20:50:26 2011 UTC (12 years, 11 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.15: +7 -8 lines
Log Message:
Fixed bug in missing persist file and changed to percentile-based threshold

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.15 2011/05/25 19:24:11 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my $tensortree = 0;
17 my $ttlog2 = 4;
18 my $nsamp = 1000;
19 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
20 my $mgfin = 0;
21 my $geout = 1;
22 my $nproc = 1;
23 my $doforw = 0;
24 my $doback = 1;
25 my @dim;
26 # Get options
27 while ($#ARGV >= 0) {
28 if ("$ARGV[0]" =~ /^[-+]m/) {
29 $mgfin = ("$ARGV[0]" =~ /^\+/);
30 } elsif ("$ARGV[0]" eq "-r") {
31 $rtargs = "$rtargs $ARGV[1]";
32 shift @ARGV;
33 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
34 $geout = ("$ARGV[0]" =~ /^\+/);
35 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
36 $doforw = ("$ARGV[0]" =~ /^\+/);
37 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
38 $doback = ("$ARGV[0]" =~ /^\+/);
39 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
40 $tensortree = substr($ARGV[0], 2, 1);
41 $ttlog2 = $ARGV[1];
42 shift @ARGV;
43 } elsif ("$ARGV[0]" eq "-c") {
44 $nsamp = $ARGV[1];
45 shift @ARGV;
46 } elsif ("$ARGV[0]" eq "-n") {
47 $nproc = $ARGV[1];
48 shift @ARGV;
49 } elsif ("$ARGV[0]" =~ /^-d/) {
50 userror() if ($#ARGV < 6);
51 @dim = @ARGV[1..6];
52 shift @ARGV for (1..6);
53 } elsif ("$ARGV[0]" =~ /^[-+]./) {
54 userror();
55 } else {
56 last;
57 }
58 shift @ARGV;
59 }
60 # Check that we're actually being asked to do something
61 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
62 # Name our own persist file?
63 my $persistfile;
64 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
65 $persistfile = "$td/pfile.txt";
66 $rtargs = "-PP $persistfile $rtargs";
67 }
68 # Get scene description and dimensions
69 my $radscn = "$td/device.rad";
70 my $mgfscn = "$td/device.mgf";
71 my $octree = "$td/device.oct";
72 if ( $mgfin ) {
73 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
74 die "Could not load MGF input\n" if ( $? );
75 system "mgf2rad $mgfscn > $radscn";
76 } else {
77 system "xform -e @ARGV > $radscn";
78 die "Could not load Radiance input\n" if ( $? );
79 system "rad2mgf $radscn > $mgfscn" if ( $geout );
80 }
81 if ($#dim != 5) {
82 @dim = split ' ', `getbbox -h $radscn`;
83 }
84 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
85 # Add receiver surfaces (rectangular)
86 my $fmodnm="receiver_face";
87 my $bmodnm="receiver_behind";
88 open(RADSCN, ">> $radscn");
89 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
90 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
91 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
92 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
93 close RADSCN;
94 # Generate octree
95 system "oconv -w $radscn > $octree";
96 die "Could not compile scene\n" if ( $? );
97 # Output XML prologue
98 print
99 '<?xml version="1.0" encoding="UTF-8"?>
100 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
101 <WindowElementType>System</WindowElementType>
102 <Optical>
103 <Layer>
104 <Material>
105 <Name>Name</Name>
106 <Manufacturer>Manufacturer</Manufacturer>
107 ';
108 printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
109 printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
110 printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
111 print "\t\t<DeviceType>Integral</DeviceType>\n";
112 # Output MGF description if requested
113 if ( $geout ) {
114 print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
115 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
116 open(MGFSCN, "< $mgfscn");
117 while (<MGFSCN>) { print $_; }
118 close MGFSCN;
119 print "xf\n";
120 print "\t\t</Geometry>\n";
121 }
122 print " </Material>\n";
123 # Set up surface sampling
124 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
125 my $ny = int($nsamp/$nx + .5);
126 $nsamp = $nx * $ny;
127 my $ns = 2**$ttlog2;
128 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
129 # Create data segments (all the work happens here)
130 if ( $tensortree ) {
131 do_tree_bsdf();
132 } else {
133 do_matrix_bsdf();
134 }
135 # Output XML epilogue
136 print
137 '</Layer>
138 </Optical>
139 </WindowElement>
140 ';
141 # Clean up temporary files and exit
142 if ( $persistfile && open(PFI, "< $persistfile") ) {
143 while (<PFI>) {
144 s/^[^ ]* //;
145 kill('ALRM', $_);
146 last;
147 }
148 close PFI;
149 }
150 exec("rm -rf $td");
151
152 #-------------- End of main program segment --------------#
153
154 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
155 sub do_tree_bsdf {
156 # Get sampling rate and subdivide task
157 my $ns2 = $ns;
158 $ns2 /= 2 if ( $tensortree == 3 );
159 @pdiv = (0, int($ns2/$nproc));
160 my $nrem = $ns2 % $nproc;
161 for (my $i = 1; $i < $nproc; $i++) {
162 my $nv = $pdiv[$i] + $pdiv[1];
163 ++$nv if ( $nrem-- > 0 );
164 push @pdiv, $nv;
165 }
166 die "Script error 1" if ($pdiv[-1] != $ns2);
167 # Shirley-Chiu mapping from unit square to disk
168 $sq2disk = '
169 in_square_a = 2*in_square_x - 1;
170 in_square_b = 2*in_square_y - 1;
171 in_square_rgn = if(in_square_a + in_square_b,
172 if(in_square_a - in_square_b, 1, 2),
173 if(in_square_b - in_square_a, 3, 4));
174 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
175 -in_square_a, -in_square_b);
176 out_disk_phi = PI/4 * select(in_square_rgn,
177 in_square_b/in_square_a,
178 2 - in_square_a/in_square_b,
179 4 + in_square_b/in_square_a,
180 if(in_square_b*in_square_b,
181 6 - in_square_a/in_square_b, 0));
182 Dx = out_disk_r*cos(out_disk_phi);
183 Dy = out_disk_r*sin(out_disk_phi);
184 Dz = sqrt(1 - out_disk_r*out_disk_r);
185 ';
186 # Shirley-Chiu mapping from unit disk to square
187 $disk2sq = '
188 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
189 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
190 in_disk_phi = norm_radians(atan2(Dy, Dx));
191 in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
192 out_square_a = select(in_disk_rgn,
193 in_disk_r,
194 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
195 -in_disk_r,
196 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
197 out_square_b = select(in_disk_rgn,
198 in_disk_phi*in_disk_r/(PI/4),
199 in_disk_r,
200 (PI - in_disk_phi)*in_disk_r/(PI/4),
201 -in_disk_r);
202 out_square_x = (out_square_a + 1)/2;
203 out_square_y = (out_square_b + 1)/2;
204 ';
205 # Announce ourselves in XML output
206 print "\t<DataDefinition>\n";
207 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
208 print "\t</DataDefinition>\n";
209 # Fork parallel rtcontrib processes to compute each side
210 if ( $doback ) {
211 for (my $proc = 0; $proc < $nproc; $proc++) {
212 bg_tree_rtcontrib(0, $proc);
213 }
214 while (wait() >= 0) {
215 die "rtcontrib process reported error" if ( $? );
216 }
217 ttree_out(0);
218 }
219 if ( $doforw ) {
220 for (my $proc = 0; $proc < $nproc; $proc++) {
221 bg_tree_rtcontrib(1, $proc);
222 }
223 while (wait() >= 0) {
224 die "rtcontrib process reported error" if ( $? );
225 }
226 ttree_out(1);
227 }
228 } # end of sub do_tree_bsdf()
229
230 # Run i'th rtcontrib process for generating tensor tree samples
231 sub bg_tree_rtcontrib {
232 my $pid = fork();
233 die "Cannot fork new process" unless defined $pid;
234 if ($pid > 0) { return $pid; }
235 my $forw = shift;
236 my $pn = shift;
237 my $pbeg = $pdiv[$pn];
238 my $plen = $pdiv[$pn+1] - $pbeg;
239 my $matargs = "-m $bmodnm";
240 if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
241 my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
242 "-e '$disk2sq' -bn '$ns*$ns' " .
243 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
244 "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
245 if ( $tensortree == 3 ) {
246 # Isotropic BSDF
247 $cmd = "cnt $plen $ny $nx " .
248 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
249 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
250 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
251 "-e 'Dx=1-($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
252 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
253 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
254 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
255 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
256 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
257 "| $cmd";
258 } else {
259 # Anisotropic BSDF
260 # Sample area vertically to improve load balance, since
261 # shading systems usually have bilateral symmetry (L-R)
262 $cmd = "cnt $plen $ns $ny $nx " .
263 "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
264 "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
265 "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
266 "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
267 "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
268 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
269 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
270 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
271 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
272 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
273 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
274 "| $cmd";
275 }
276 # print STDERR "Starting: $cmd\n";
277 exec($cmd); # no return; status report to parent via wait
278 die "Cannot exec: $cmd\n";
279 } # end of bg_tree_rtcontrib()
280
281 # Simplify and output tensor tree results
282 sub ttree_out {
283 my $forw = shift;
284 my $side = ("Back","Front")[$forw];
285 # Only output one transmitted distribution, preferring backwards
286 if ( !$forw || !$doback ) {
287 print
288 ' <WavelengthData>
289 <LayerNumber>System</LayerNumber>
290 <Wavelength unit="Integral">Visible</Wavelength>
291 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
292 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
293 <WavelengthDataBlock>
294 <WavelengthDataDirection>Transmission</WavelengthDataDirection>
295 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
296 <ScatteringDataType>BTDF</ScatteringDataType>
297 <ScatteringData>
298 ';
299 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
300 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
301 "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
302 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
303 die "Failure running rttree_reduce" if ( $? );
304 print
305 ' </ScatteringData>
306 </WavelengthDataBlock>
307 </WavelengthData>
308 ';
309 }
310 # Output reflection
311 print
312 ' <WavelengthData>
313 <LayerNumber>System</LayerNumber>
314 <Wavelength unit="Integral">Visible</Wavelength>
315 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
316 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
317 <WavelengthDataBlock>
318 <WavelengthDataDirection>Reflection $side</WavelengthDataDirection>
319 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
320 <ScatteringDataType>BRDF</ScatteringDataType>
321 <ScatteringData>
322 ';
323 system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
324 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
325 "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
326 "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
327 die "Failure running rttree_reduce" if ( $? );
328 print
329 ' </ScatteringData>
330 </WavelengthDataBlock>
331 </WavelengthData>
332 ';
333 } # end of ttree_out()
334
335 #------------- End of do_tree_bsdf() & subroutines -------------#
336
337 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
338 sub do_matrix_bsdf {
339 # Set up sampling of portal
340 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
341 $tcal = '
342 DEGREE : PI/180;
343 sq(x) : x*x;
344 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
345 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
346 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
347 Kmax : Kaccum(Knaz(0));
348 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
349 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
350 Kcol = Kbin - Kaccum(Krow-1);
351 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
352 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
353 sin_kpol = sin(Kpol);
354 Dx = cos(Kazi)*sin_kpol;
355 Dy = sin(Kazi)*sin_kpol;
356 Dz = sqrt(1 - sin_kpol*sin_kpol);
357 KprojOmega = PI * if(Kbin-.5,
358 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
359 1 - sq(cos(Kpola(1)*DEGREE)));
360 ';
361 # Compute Klems bin from exiting ray direction (forward or backward)
362 $kcal = '
363 DEGREE : PI/180;
364 abs(x) : if(x, x, -x);
365 Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
366 posangle(a) : if(-a, a + 2*PI, a);
367 Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
368 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
369 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
370 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
371 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
372 if(pol-kpola(r), kfindrow(r+1, pol), r) );
373 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
374 kbin2(pol,azi) = select(kfindrow(1, pol),
375 kazn(azi,360/knaz(1)),
376 kaccum(1) + kazn(azi,360/knaz(2)),
377 kaccum(2) + kazn(azi,360/knaz(3)),
378 kaccum(3) + kazn(azi,360/knaz(4)),
379 kaccum(4) + kazn(azi,360/knaz(5)),
380 kaccum(5) + kazn(azi,360/knaz(6)),
381 kaccum(6) + kazn(azi,360/knaz(7)),
382 kaccum(7) + kazn(azi,360/knaz(8)),
383 kaccum(8) + kazn(azi,360/knaz(9))
384 );
385 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
386 ';
387 my $ndiv = 145;
388 # Compute scattering data using rtcontrib
389 my @tfarr;
390 my @rfarr;
391 my @tbarr;
392 my @rbarr;
393 my $cmd;
394 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
395 "-e '$kcal' -b kbin -bn $ndiv " .
396 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
397 my $rccmd = "rcalc -e '$tcal' " .
398 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
399 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
400 if ( $doforw ) {
401 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
402 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
403 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
404 "-e 'zp:$dim[4]' " .
405 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
406 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
407 "| $rtcmd";
408 system "$cmd" || die "Failure running: $cmd\n";
409 @tfarr = `$rccmd $td/$fmodnm.flt`;
410 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
411 @rfarr = `$rccmd $td/$bmodnm.flt`;
412 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
413 }
414 if ( $doback ) {
415 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
416 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
417 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
418 "-e 'zp:$dim[5]' " .
419 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
420 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
421 "| $rtcmd";
422 system "$cmd" || die "Failure running: $cmd\n";
423 @tbarr = `$rccmd $td/$bmodnm.flt`;
424 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
425 @rbarr = `$rccmd $td/$fmodnm.flt`;
426 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
427 }
428 # Output angle basis
429 print
430 ' <DataDefinition>
431 <IncidentDataStructure>Columns</IncidentDataStructure>
432 <AngleBasis>
433 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
434 <AngleBasisBlock>
435 <Theta>0</Theta>
436 <nPhis>1</nPhis>
437 <ThetaBounds>
438 <LowerTheta>0</LowerTheta>
439 <UpperTheta>5</UpperTheta>
440 </ThetaBounds>
441 </AngleBasisBlock>
442 <AngleBasisBlock>
443 <Theta>10</Theta>
444 <nPhis>8</nPhis>
445 <ThetaBounds>
446 <LowerTheta>5</LowerTheta>
447 <UpperTheta>15</UpperTheta>
448 </ThetaBounds>
449 </AngleBasisBlock>
450 <AngleBasisBlock>
451 <Theta>20</Theta>
452 <nPhis>16</nPhis>
453 <ThetaBounds>
454 <LowerTheta>15</LowerTheta>
455 <UpperTheta>25</UpperTheta>
456 </ThetaBounds>
457 </AngleBasisBlock>
458 <AngleBasisBlock>
459 <Theta>30</Theta>
460 <nPhis>20</nPhis>
461 <ThetaBounds>
462 <LowerTheta>25</LowerTheta>
463 <UpperTheta>35</UpperTheta>
464 </ThetaBounds>
465 </AngleBasisBlock>
466 <AngleBasisBlock>
467 <Theta>40</Theta>
468 <nPhis>24</nPhis>
469 <ThetaBounds>
470 <LowerTheta>35</LowerTheta>
471 <UpperTheta>45</UpperTheta>
472 </ThetaBounds>
473 </AngleBasisBlock>
474 <AngleBasisBlock>
475 <Theta>50</Theta>
476 <nPhis>24</nPhis>
477 <ThetaBounds>
478 <LowerTheta>45</LowerTheta>
479 <UpperTheta>55</UpperTheta>
480 </ThetaBounds>
481 </AngleBasisBlock>
482 <AngleBasisBlock>
483 <Theta>60</Theta>
484 <nPhis>24</nPhis>
485 <ThetaBounds>
486 <LowerTheta>55</LowerTheta>
487 <UpperTheta>65</UpperTheta>
488 </ThetaBounds>
489 </AngleBasisBlock>
490 <AngleBasisBlock>
491 <Theta>70</Theta>
492 <nPhis>16</nPhis>
493 <ThetaBounds>
494 <LowerTheta>65</LowerTheta>
495 <UpperTheta>75</UpperTheta>
496 </ThetaBounds>
497 </AngleBasisBlock>
498 <AngleBasisBlock>
499 <Theta>82.5</Theta>
500 <nPhis>12</nPhis>
501 <ThetaBounds>
502 <LowerTheta>75</LowerTheta>
503 <UpperTheta>90</UpperTheta>
504 </ThetaBounds>
505 </AngleBasisBlock>
506 </AngleBasis>
507 </DataDefinition>
508 ';
509 if ( $doforw ) {
510 print
511 ' <WavelengthData>
512 <LayerNumber>System</LayerNumber>
513 <Wavelength unit="Integral">Visible</Wavelength>
514 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
515 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
516 <WavelengthDataBlock>
517 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
518 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
519 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
520 <ScatteringDataType>BTDF</ScatteringDataType>
521 <ScatteringData>
522 ';
523 # Output front transmission (transposed order)
524 for (my $od = 0; $od < $ndiv; $od++) {
525 for (my $id = 0; $id < $ndiv; $id++) {
526 print $tfarr[$ndiv*$id + $od];
527 }
528 print "\n";
529 }
530 print
531 ' </ScatteringData>
532 </WavelengthDataBlock>
533 </WavelengthData>
534 <WavelengthData>
535 <LayerNumber>System</LayerNumber>
536 <Wavelength unit="Integral">Visible</Wavelength>
537 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
538 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
539 <WavelengthDataBlock>
540 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
541 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
542 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
543 <ScatteringDataType>BRDF</ScatteringDataType>
544 <ScatteringData>
545 ';
546 # Output front reflection (transposed order)
547 for (my $od = 0; $od < $ndiv; $od++) {
548 for (my $id = 0; $id < $ndiv; $id++) {
549 print $rfarr[$ndiv*$id + $od];
550 }
551 print "\n";
552 }
553 print
554 ' </ScatteringData>
555 </WavelengthDataBlock>
556 </WavelengthData>
557 ';
558 }
559 if ( $doback ) {
560 print
561 ' <WavelengthData>
562 <LayerNumber>System</LayerNumber>
563 <Wavelength unit="Integral">Visible</Wavelength>
564 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
565 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
566 <WavelengthDataBlock>
567 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
568 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
569 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
570 <ScatteringDataType>BTDF</ScatteringDataType>
571 <ScatteringData>
572 ';
573 # Output back transmission (transposed order)
574 for (my $od = 0; $od < $ndiv; $od++) {
575 for (my $id = 0; $id < $ndiv; $id++) {
576 print $tbarr[$ndiv*$id + $od];
577 }
578 print "\n";
579 }
580 print
581 ' </ScatteringData>
582 </WavelengthDataBlock>
583 </WavelengthData>
584 <WavelengthData>
585 <LayerNumber>System</LayerNumber>
586 <Wavelength unit="Integral">Visible</Wavelength>
587 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
588 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
589 <WavelengthDataBlock>
590 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
591 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
592 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
593 <ScatteringDataType>BRDF</ScatteringDataType>
594 <ScatteringData>
595 ';
596 # Output back reflection (transposed order)
597 for (my $od = 0; $od < $ndiv; $od++) {
598 for (my $id = 0; $id < $ndiv; $id++) {
599 print $rbarr[$ndiv*$id + $od];
600 }
601 print "\n";
602 }
603 print
604 ' </ScatteringData>
605 </WavelengthDataBlock>
606 </WavelengthData>
607 ';
608 }
609 }
610 #------------- End of do_matrix_bsdf() --------------#